package com.servoy.extensions.plugin.serverpluginexample;

import java.rmi.RemoteException;

import com.servoy.j2db.plugins.IClientPluginAccess;
import com.servoy.j2db.scripting.IScriptObject;

public class ScriptObject  implements IScriptObject {
	
	private IClientPluginAccess application;
	private ServerService ss;
	
	public ScriptObject(IClientPluginAccess app){
		application = app;
	}
	
	//All methods starting with js_ will show up in the Servoy Object Module
	//under plugins with the js_ omitted
	public String js_helloWorld(String input){
		//make sure server connection is there
		getServerConnection();
		
		//make the call to the server method
		String myReturn;
		try {
			myReturn = ss.helloWorldServer(input);
		} catch (RemoteException e) {
			myReturn = "";
		}
		
		return myReturn;
	}
	
	//private call to get the connection to the server
	private void getServerConnection(){
		if(ss == null){ //only create it if it hasn't been created yet
			try {
				ss = (ServerService) application.getServerService("com.servoy.extensions.plugins.serverpluginexample");
			} catch (Exception e) {
			}
		}
	}
	
	
	public String[] getParameterNames(String methodName) {
		if("helloWorld".equals(methodName))
			return new String[]{"input"};

		return null;
	}
	
	public String getSample(String arg0) {
		return null;
	}
	
	public String getToolTip(String methodName) {
		if("helloWorld".equals(methodName))
			return "Example Server call.  Send in hello, and world will be added to the end and returned";

		return null;
	}
	
	public boolean isDeprecated(String arg0) {
		return false;
	}
	
	public Class[] getAllReturnedTypes() {
		return null;
	}
}
